/*
 * function to just return year and week number
 */
proc fcmp outlib=work.myfunc.convert;
  function myweekv(someDate) $ 8;
    return ( substr(put(someDate, weekv11.), 1, 8) );
  endsub;
quit;

options cmplib=(work.myfunc _displayloc_);

/*
 * use function in a format
 */
proc format;
  value myweekv8f (default=8)
    low - high = [ myweekv() ]
  ;
run;

/*
 * use both format and function
 */
data year_month_week;
  do year = 2018 to 2019;
    do xdate = mdy(12, 24, year) to mdy(12, 24, year) + 14;
      date_c = put(xdate, WEEKDATX. -L);
      xdate_weekv = xdate;
      xdate_myweekv8f = xDate;
      xdate_myweekv = myweekv(xDate);
      output;
    end;
  end;
  format xdate date9. xdate_weekv weekv. xdate_myweekv8f myweekv8f.;
  drop year;
run;