*
* switch on DBMS trace
*;
options 
  sastrace = ",,,d"
  sastraceloc = saslog
  nostsuffix
;

%let orapath = xe;
%let orauser = educ;
%let orapasswd = educ;

*
* assign library to DBMS
*;
libname ora oracle
  path=&orapath
  user=&orauser
  password=&orapasswd
;
 
*
* delete and create sample data
*;
proc sql;
  drop table ora.celcius;
quit;

data ora.celcius;
  do c = -5 to 40 by 5;
    xrow+ 1; 
    output;
  end;
run;

*
* assign library to DBMS
*;
libname ora oracle
  path=&orapath
  user=&orauser
  password=&orapasswd
;

*
* create and test the function using pass through
*;
proc sql;
  connect using ora;
  execute (
    create or replace function ctof (C in number)
      return number is F number(11,1);
      begin
        return(C*1.8+32);
      end;

  ) by ora;

  title "Function test using explicit pass through";
  select
    *
  from
    connection to ora (
      select
        c
        , ctof(c) as f
      from
        celcius
  ); 
  disconnect from ora;
quit;

*
* create the dummy SAS function
*;
proc fcmp 
  outlib=work.funcs.trial
; 
  function ctof(x); 
     return(n);
  endsub; 
run;
 
options
  cmplib=work.funcs
; 

*
* add dummy function to function dictionary used by SAS/ACCESS
*;
data work.dict;
  sasfuncname = 'CTOF';
  sasfuncnamelen = 4;
  dbmsfuncname = 'CTOF';
  dbmsfuncnamelen = 4;
  function_category = ' ';
  func_usage_context = 'SELECT_LIST';
  convert_args = 0;
  engineindex = 0;
  function_returntyp = 'NUMERIC';
  function_num_args = 1;                                                          
run;        
    
*
* assign library to DBMS with custom dictionary
*;
libname ora oracle
  path=&orapath
  user=&orauser
  password=&orapasswd
  SQL_FUNCTIONS="EXTERNAL_APPEND=WORK.DICT"
  SQL_FUNCTIONS_COPY=saslog
;

 
*
* test out the function using SAS code
*;
proc sql;
  title "function from SAS, does not work";
  select
    c
    , ctof(c) as f
  from
    ora.celcius
  ;
  title "function from SAS, work with order by";
  select
    c
    , ctof(c) as f
  from
    ora.celcius
  order by  
    xrow
  ;

quit;
title;

